#!/usr/bin/python
# -*- coding: latin-1 -*-
###
#
# This file is the legal property of Jean-Pierre Redonnet <redonnetbrouk@aol.com>
# Copyright (c) 2006 Jean-Pierre Redonnet
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###
#!/usr/bin/env python
# -*- Encoding: Latin-1 -*-

import pygtk
pygtk.require('2.0')
import gtk, gobject
import sys,os,string
from time import localtime,strftime,strptime,mktime,clock

#default paths
path_media_disk="/media/disk" #floppy, cdrom, usb_disk
path_manual="/usr/share/justfordeb/doc" # html doc
home_user_path="./"
pack_path="/packageur"

INSTALL_DIR=a2="/usr/share/<myprog>"
MAN_DIR=a3="/usr/share/man/man1"
BIN_DIR=a4="/usr/bin"
APP_DIR=a5="/usr/share/applications"
LOC_DIR=a6="/usr/share/locale"
ICO_DIR=a7="/usr/share/<myprog>/icons"
#Extensions program:.py and icon:.png
ext_exe='.py'
ext_ico='.png'

#version
version="0.11"
date_version="May 2nd 2008"


def boolean(word):
    if 'True' in word: return(True)
    return(False)

def update_path(myprogram):
    global INSTALL_DIR,ICO_DIR,packager_path
    #replace myprog with the real program name for each paths
    packager_path=string.replace(a1,'<myprog>',myprogram)
    INSTALL_DIR=string.replace(a2,'<myprog>',myprogram)
    ICO_DIR=string.replace(a7,'<myprog>',myprogram)

def create_package(folder,myprogram,version):
    Err=''
    Done=''

    VERSION=version

    directory=os.path.join(folder,myprogram)
    os.makedirs(directory+'/DEBIAN')
    f=open(directory+'/DEBIAN/control','w')
    f.write(control_install)
    f.close()
    os.makedirs(directory+APP_DIR)
    f=open(directory+APP_DIR+'/'+myprogram+'.desktop','w')
    f.write(desktop_file)
    f.close()
    os.makedirs(directory+ICO_DIR)
    file=myprogram
    try: os.rename(folder+'/'+file+ext_ico,directory+ICO_DIR+'/'+file+ext_ico)
    except: Err=Err+'ICO '
    os.makedirs(directory+INSTALL_DIR+"/doc")
    try: os.rename(folder+'/'+myprogram+'.html',directory+INSTALL_DIR+'/doc/'+myprogram+'.html')
    except: Err=Err+'HTML '
    else:
        os.system('chmod u=rw,a+r '+directory+INSTALL_DIR+'/doc/'+myprogram+'.html')
        os.system('chown root '+directory+INSTALL_DIR+'/doc/'+myprogram+'.html')
    try: os.rename(folder+'/readme.txt',directory+INSTALL_DIR+'/doc/readme.txt')
    except: Err=Err+'README '
    os.makedirs(directory+MAN_DIR)
    try: os.rename(folder+'/'+myprogram+'.1.gz',directory+MAN_DIR+'/'+myprogram+'.1.gz')
    except: Err=Err+'MANPAGE '
        #chmod u=rw,a+r myprogram.1.gz
        #chown root myprogram.1.gz
    os.makedirs(directory+BIN_DIR)
    try: os.rename(folder+'/'+myprogram+ext_exe,directory+BIN_DIR+'/'+myprogram+ext_exe)
    except: Err=Err+'Py_PROG '
    else:
        os.system('chmod u=rwx,go+rx '+directory+BIN_DIR+'/'+myprogram+ext_exe)
        os.system('chown root '+directory+BIN_DIR+'/'+myprogram+ext_exe)
    os.makedirs(directory+INSTALL_DIR+"/res")
    try: os.rename(folder+'/'+myprogram+'.glade',directory+INSTALL_DIR+'/res/'+myprogram+'.glade')
    except: Err=Err+'GLADE '
    os.makedirs(directory+LOC_DIR)
    os.makedirs(directory+INSTALL_DIR+"/src")

def update_package(folder,myprogram,version):
    directory=os.path.join(folder,myprogram)
    try: f=open(directory+'/DEBIAN/control','w')
    except:
        return('Error update control')
    f.write(control_install)
    f.close()
    try: f=open(directory+APP_DIR+'/'+myprogram+'.desktop','w')
    except:
        return('Error update desktop file')
    f.write(desktop_file)
    f.close()
    return('Updated')

class App:
    pass

#### GUI with GTK

def load_conf_package(entry, data):
    app = data
    #check if do_not_remove_me in Work folder
    folder=string.strip(app.entry1.get_text())
    if 'file:///'==folder[:8]: #copy-paste with xfce4 requires some trt
        folder=folder[7:-2]
        app.entry1.set_text(folder)
    if not os.path.isdir(folder):
        app.label.set_text("Path: "+folder+" doesn't exist!")
        return()
    else:
        app.label.set_text("")
    #get name,version,comment...
    try: f=open(folder+'/do_not_move_me.cfg','r')
    except:
        app.label.set_text("Path: "+folder+" doesn't exist!")
        return()
    #extract each field
    for field in f:
        if ':' in field:
            (name,content)=string.split(field,':',2)
            if content<>'': content=content[:-1] #remove \n at the end
            if 'progname' in name: app.entry2.set_text(content)
            if 'version' in name: app.entry3.set_text(content)
            if 'comment' in name: app.entry4.set_text(content)
            if 'binpath' in name:
                BIN_DIR=content
                app.entry5.set_text(content)
            if 'binext' in name:
                ext_exe=content
                app.entry5b.set_text(content)   
            if 'icopath' in name:
                ICO_DIR=content
                app.entry6.set_text(content)
            if 'icoext' in name:
                ext_ico=content
                app.entry6b.set_text(content)    
            if 'categories' in name: app.combo.set_active(string.atoi(content))
            if 'depends' in name: app.entry8.set_text(content)
            if 'maintainer' in name: app.entry9.set_text(content)
            #set flags
            if 'terminal' in name: app.check1.set_active(boolean(content))
            if 'multiplargs' in name: app.check2.set_active(boolean(content))
            if 'startupnotif' in name: app.check3.set_active(boolean(content))
    f.close()
    return()

def save_conf_package(entry, data):
    app = data
    #check if do_not_remove_me in Work folder
    folder=string.strip(app.entry1.get_text())
    if 'file:///'==folder[:8]: #copy-paste with xfce4 requires some trt
        folder=folder[7:-2]
        app.entry1.set_text(folder)
    folder+='/do_not_move_me.cfg'
    """
    if os.path.isdir(folder):
        app.label.set_text("Path: "+folder+" exist!")
        return()
    else:
        app.label.set_text("")
    """
    #get & save: name,version,comment...
    f=open(folder,'w')
    f.write('jfdversion:'+version+'\n')
    f.write('datecreated:'+strftime("%a %d %b %Y %Hh%Mm%Ss",localtime())+'\n')
    f.write('workfolder:'+string.strip(app.entry1.get_text())+'\nprogname:'+string.strip(app.entry2.get_text())+'\nversion:'+string.strip(app.entry3.get_text())+'\ncomment:'+string.strip(app.entry4.get_text())+'\n')
    f.write('binpath:'+string.strip(app.entry5.get_text())+'\n')
    f.write('binext:'+string.strip(app.entry5b.get_text())+'\n')
    f.write('icopath:'+string.strip(app.entry6.get_text())+'\n')
    f.write('icoext:'+string.strip(app.entry6b.get_text())+'\n')
    f.write('categories:'+repr(app.combo.get_active())+'\n')
    f.write('depends:'+string.strip(app.entry8.get_text())+'\n')
    f.write('maintainer:'+string.strip(app.entry9.get_text())+'\n')
    f.write('terminal:'+repr(app.check1.get_active())+'\n')
    f.write('multiplargs:'+repr(app.check2.get_active())+'\n')
    f.write('startupnotif:'+repr(app.check3.get_active())+'\n')
    f.close()
    return()

def OnQuit(entry, data):
    app = data
    gtk.main_quit()

def OnCreate(entry, data, update):
    global control_install,desktop_file,ext_exe,ext_ico
    app = data
    #check if Work folder exist    
    folder=string.strip(app.entry1.get_text())
    if 'file:///'==folder[:8]: #copy-paste with xfce4 requires some trt
        folder=folder[7:-2]
        app.entry1.set_text(folder)
    if not os.path.isdir(folder):
        app.label.set_text("Path: "+folder+" doesn't exist!")
        return()
    else:
        app.label.set_text("")
    #get name,version,comment,paths,categories,dependence,maintainer and some flags
    progname=string.strip(app.entry2.get_text())
    if progname=='':
        app.label.set_text("File is empty!")
        return()
    elif '.' in progname:
        app.label.set_text("File: "+progname+" is not valid!")
        return()
    else: app.label.set_text("")

    version=string.strip(app.entry3.get_text())
    if version=='':
        app.label.set_text("Version number is needed!")
        return()
    else: app.label.set_text("")

    comment=string.strip(app.entry4.get_text())
    if comment=='':
        app.label.set_text("Comment field is empty!")
        return()
    else: app.label.set_text("")

    execpath=string.strip(app.entry5.get_text())
    if execpath=='':
        app.label.set_text("Path of executable is empty!")
        return()
    else: app.label.set_text("")

    ext_exe=string.strip(app.entry5b.get_text())
    if ext_exe=='':
        app.label.set_text("Executable extension is empty!")
        return()
    else: app.label.set_text("")
    
    iconpath=string.strip(app.entry6.get_text())
    if iconpath=='':
        app.label.set_text("Path of icon is empty!")
        return()
    else: app.label.set_text("")

    ext_ico=string.strip(app.entry6b.get_text())
    if ext_ico=='':
        app.label.set_text("Path of icon is empty!")
        return()
    else: app.label.set_text("")

    iter = app.combo.get_active_iter()
    app.model = app.combo.get_model()
    category = app.model.get_value(iter, 1)
    if category=='':
        app.label.set_text("Category field is empty!")
        return()
    else: app.label.set_text("")

    depends=string.strip(app.entry8.get_text())
    if depends=='':
        app.label.set_text("Dependence is empty!")
        return()
    else: app.label.set_text("")

    maintainer=string.strip(app.entry9.get_text())
    if maintainer=='':
        app.label.set_text("Maintainer field is empty!")
        return()
    else: app.label.set_text("")

    if app.check1.get_active(): terminal='true'
    else: terminal='false'

    if app.check2.get_active(): multiplargs='true'
    else: multiplargs='false'

    if app.check3.get_active(): startupnotify='true'
    else: startupnotify='false'
    #create info
    save_conf_package(entry,data)
    #create desktop file
    desktop_file='[Desktop Entry]\n'+'Name='+progname+'\n'+'Comment='+comment+'\n'+'Exec='+execpath+'/'+progname+ext_exe+'\n'+'Icon='+iconpath+'/'+progname+ext_ico+'\n'+'Terminal='+terminal+'\n'+'MultipleArgs='+multiplargs+'\n'+'Type=Application\n'+'Categories='+category+'\n'+'StartupNotify='+startupnotify+'\n'
    #create debian control file
    control_install='Package: '+progname+'\n'+'Version: '+version+'\n'+'Section: '+category+'\n'+'Priority: optional\n'+'Architecture: i386\n'+'Depends: '+depends+'\n'+'Maintainer: '+maintainer+'\n'+'Description: '+comment+'\n'
    if update==0:
        #create DEBIAN folder
        create_package(folder,progname,version)
    elif update==1:
        #update DEBIAN folder
        app.label.set_text(update_package(folder,progname,version))

def OnPack(entry,data):
    app = data
    #check if DEBIAN exist
    folder=string.strip(app.entry1.get_text())
    if 'file:///'==folder[:8]: #copy-paste with xfce4 requires some trt
        folder=folder[7:-2]
        app.entry1.set_text(folder)
    """
    if not os.path.isdir(folder+'/DEBIAN'):
        app.label.set_text("Path: "+folder+" doesn't exist!")
        return()
    else:
        app.label.set_text("ok1")
    """
    #get name & version
    progname=string.strip(app.entry2.get_text())
    if progname=='':
        app.label.set_text("File is empty!")
        return()
    elif '.' in progname:
        app.label.set_text("File: "+progname+" is not valid!")
        return()
    else: app.label.set_text("ok2")
    version=string.strip(app.entry3.get_text())
    if version=='':
        app.label.set_text("Version number is needed!")
        return()
    else: app.label.set_text("ok3")
    #create package
    dpkg_debian='xterm -e "dpkg-deb --build '+folder+'/'+progname+' '+folder+'/'+progname+'-'+version+'.deb;read a$"'
    os.system(dpkg_debian)    

def OnFiles(entry,data):
    app = data
    #check if work folder exist
    folder=string.strip(app.entry1.get_text())
    if 'file:///'==folder[:8]: #copy-paste with xfce4 requires some trt
        folder=folder[7:-2]
        app.entry1.set_text(folder)
    if not os.path.isdir(folder):
        app.label.set_text("Path: "+folder+" doesn't exist!")
        folder=string.replace(a1,'<myprog>','')
    else:
        app.label.set_text("")
    #start files browser
    os.system('rox '+folder)


def OnHelp(entry, data):
    app = data
    dia = gtk.Dialog('Help',
        None,  #the toplevel wgt of your app
        gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,  #binary flags or'ed together
        ('_More info', 77,gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE))
    dia.vbox.pack_start(gtk.Label('\nJP Redonnet\nVers. '+version+' - '+date_version+'\nBuild a Debian package of Python programs\n\n'+
                                  '1 - First Complete the fields (Program name without extension)\n'+
                                  '2 - Click on (1) Work Folder button\n'+
                                  '3 - Next click on (2) Files browser button and copy the files in the Work folder\n'+
                                  '4 - Then click on (3) Organize files button to create the Destination folder\n'+
                                  '5 - Move the residual files in their respective locations in Destination folder\n'+
                                  '6 - Eventually change the files permissions\n'+
                                  '7 - Click on (5) Build package button (then the packager should be in the Work folder)\n'+
                                  'Notes: (4) Update ctrl allows you to change the control & desktop files\n '+
                                  'if an invalid package blocks your package manager,\n'+
                                  'remove it with: sudo dpkg --force-remove-reinstreq --remove <prog_name>\n'))
    dia.show_all()
    result = dia.run()
    dia.destroy() 
    if result == 77:
        fp=os.popen('xterm -e man justfordeb &')
        gtk.REPONSE_CLOSE


def OnName(entry, data):
    app = data
    #get program name    
    progname=string.strip(app.entry2.get_text())
    if progname=='':
        app.label.set_text("File is empty!")
        return()
    elif '.' in progname:
        app.label.set_text("File: "+progname+" is not valid!")
        return()
    else: app.label.set_text("")
    #replace <myprog> with the program name
    update_path(progname)
    #create de Work folder if it doesn't exist
    if not os.path.isdir(packager_path):
        try: os.mkdir(packager_path) #create the path
        except:
            app.label.set_text("Path: "+packager_path+" cannot be created :-(")
            return()
        else:
            app.label.set_text("Path: "+packager_path+" has been created :-)")
    #update fields
    app.entry1.set_text(packager_path)
    app.entry5.set_text(BIN_DIR)
    app.entry6.set_text(ICO_DIR)
    app.label.set_text("")
    #check if 'do_not_move_me' file exist then load fields(name,version,comment...)
    load_conf_package(entry,data)    
    
def OnNew(entry, data): #restore paths
    app = data
    #restore paths
    packager_path=a1
    INSTALL_DIR=a2
    MAN_DIR=a3
    BIN_DIR=a4
    APP_DIR=a5
    LOC_DIR=a6
    ICO_DIR=a7
    #restore fields
    app.entry1.set_text(packager_path)
    app.entry2.set_text("")
    app.entry3.set_text("")
    app.entry5.set_text(BIN_DIR)
    app.entry6.set_text(ICO_DIR)
    app.label.set_text("")

def main():   
    app = App()

    #Categories choice displayed in Combo box
    store = gtk.TreeStore(gobject.TYPE_INT, gobject.TYPE_STRING)
    iter = store.append(None)
    store.set(iter, 0, 1, 1, "Application")
    iter = store.append(None)
    store.set(iter, 0, 2, 1, "Audio;AudioVideo")
    iter = store.append(None)
    store.set(iter, 0, 3, 1, "Development")
    iter = store.append(None)
    store.set(iter, 0, 4, 1, "Education")
    iter = store.append(None)
    store.set(iter, 0, 5, 1, "Education;Science")
    iter = store.append(None)
    store.set(iter, 0, 6, 1, "Game")
    iter = store.append(None)
    store.set(iter, 0, 7, 1, "Game;Player")
    iter = store.append(None)
    store.set(iter, 0, 8, 1, "Network")
    iter = store.append(None)
    store.set(iter, 0, 9, 1, "Setting")
    iter = store.append(None)
    store.set(iter, 0, 10, 1, "Settings;Desktopsettings")
    iter = store.append(None)
    store.set(iter, 0, 11, 1, "Utility")
    iter = store.append(None)
    store.set(iter, 0, 12, 1, "Utility;Filesystem")
    iter = store.append(None)
    store.set(iter, 0, 13, 1, "Utility;Texteditor")    
    iter = store.append(None)
    store.set(iter, 0, 14, 1, "WordProcessor;Office")
    #End of categories choice
    
    app.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    app.window.set_title('Just for Debian '+version)
    app.window.set_default_size(200, 100)
    app.window.set_border_width(5)
    app.window.connect("destroy", OnQuit, None)

    app.vbox = gtk.VBox(False, 5)
    app.h1box = gtk.HBox(False, 5)
    app.h2box = gtk.HBox(False, 5)
    app.h3box = gtk.HBox(False, 5)
    app.h4box = gtk.HBox(False, 5)
  
    app.window.add(app.vbox)

    # button restore paths
    app.button1 = gtk.Button("_Clear path",gtk.STOCK_CLEAR)
    app.h1box.pack_start(app.button1, False, False, 0)
    #=>entry 1 moved after entry 3
    # entry 2 prog name
    app.entry2 = gtk.Entry()
    app.frame2 = gtk.Frame('Program name')
    app.frame2.add(app.entry2)
    app.h1box.pack_start(app.frame2, False, False, 0)
    # entry 3 Version
    app.entry3 = gtk.Entry()
    app.frame3 = gtk.Frame('Version')
    app.frame3.add(app.entry3)
    app.h1box.pack_start(app.frame3, False, False, 0)
    app.vbox.add(app.h1box)
    app.entry3.set_width_chars(8)
    # entry 1  path
    app.entry1 = gtk.Entry()
    app.frame1 = gtk.Frame('Files path')
    app.frame1.add(app.entry1)
    app.h1box.pack_start(app.frame1, False, False, 0)
    app.entry1.set_width_chars(30)
    # entry 4  Comment
    app.entry4 = gtk.Entry()
    app.frame4 = gtk.Frame('Comment')
    app.frame4.add(app.entry4)
    app.vbox.pack_start(app.frame4, False, False, 0)
    # entry 5 Exec path
    app.entry5 = gtk.Entry()
    app.frame5 = gtk.Frame('Executable path')
    app.frame5.add(app.entry5)
    app.h2box.pack_start(app.frame5, False, False, 0)
    # entry 5bis Exec extension
    app.entry5b = gtk.Entry()
    app.frame5b = gtk.Frame('Exe ext')
    app.frame5b.add(app.entry5b)
    app.h2box.pack_start(app.frame5b, False, False, 0)
    app.entry5b.set_width_chars(5)
    # entry 6 Ico path
    app.entry6 = gtk.Entry()
    app.frame6 = gtk.Frame('Icon path')
    app.frame6.add(app.entry6)
    app.h2box.pack_start(app.frame6, False, False, 0)
    # entry 6bis Ico extension
    app.entry6b = gtk.Entry()
    app.frame6b = gtk.Frame('Ico ext')
    app.frame6b.add(app.entry6b)
    app.h2box.pack_start(app.frame6b, False, False, 0)
    app.entry6b.set_width_chars(5)
    # Combo 7 Categorie
    app.combo = gtk.ComboBox(store)
    app.renderer = gtk.CellRendererText()
    app.combo.pack_start(app.renderer, True)
    app.combo.add_attribute(app.renderer, 'text', 1)
    app.combo.set_active(0)
    app.frame7 = gtk.Frame('Categorie-section')
    app.frame7.add(app.combo)
    app.h2box.pack_start(app.frame7, False, False, 0)
    app.vbox.add(app.h2box)
    # entry 8 Depends
    app.entry8 = gtk.Entry()
    app.frame8 = gtk.Frame('Depends')
    app.frame8.add(app.entry8)
    app.vbox.pack_start(app.frame8, False, False, 0)
    # entry 9 Maintainer
    app.entry9 = gtk.Entry()
    app.frame9 = gtk.Frame('Maintainer & email')
    app.frame9.add(app.entry9)
    app.vbox.pack_start(app.frame9, False, False, 0)
    # check Terminal 
    app.check1 = gtk.CheckButton("Terminal mode")
    app.h3box.pack_start(app.check1, False, False, 0)
    app.check1.set_active(False)
    # check MultipleArgs
    app.check2 = gtk.CheckButton("MultipleArgs")
    app.h3box.pack_start(app.check2, False, False, 0)
    app.check2.set_active(False)
    # check StartupNotify
    app.check3 = gtk.CheckButton("StartupNotify")
    app.h3box.pack_start(app.check3, False, False, 0)
    app.check3.set_active(True)
    app.vbox.add(app.h3box)
    # Dialog label
    app.label = gtk.Label()
    app.frame = gtk.Frame('Dialog')
    app.label.set_line_wrap(True)
    app.frame.add(app.label)
    app.vbox.pack_start(app.frame, False, False, 0)
    # Buttons
    app.button2 = gtk.Button("1 _Work folder")
    app.h4box.pack_start(app.button2, False, False, 0)
    app.button3 = gtk.Button("2 _Files browser")
    app.h4box.pack_start(app.button3, False, False, 0)
    app.button4 = gtk.Button("3 _Organize files")
    app.h4box.pack_start(app.button4, False, False, 0)
    app.button5 = gtk.Button("4 _Update ctrl")
    app.h4box.pack_start(app.button5, False, False, 0)  
    app.button6 = gtk.Button("5 _Build package")
    app.h4box.pack_start(app.button6, False, False, 0)  
    app.button7 = gtk.Button("_Help",gtk.STOCK_HELP)
    app.h4box.pack_start(app.button7, False, False, 0)

    app.vbox.add(app.h4box)

    app.entry2.connect("activate",OnName,app)
    app.button1.connect("clicked", OnNew, app)   
    app.button2.connect("clicked", OnName, app)
    app.button3.connect("clicked", OnFiles, app)
    app.button4.connect("clicked", OnCreate, app,0)
    app.button5.connect("clicked", OnCreate, app,1)
    app.button6.connect("clicked", OnPack, app)
    app.button7.connect("clicked", OnHelp, app)

    app.entry1.set_text(packager_path)
    app.entry5.set_text(BIN_DIR)
    app.entry6.set_text(ICO_DIR)
    app.entry5b.set_text(ext_exe)
    app.entry6b.set_text(ext_ico)
        
    app.window.show_all()
  
    gtk.main()  
    
# -------------program starts here !--------------------------

chaine=sys.argv[0]
home_user_path=os.path.expanduser('~')
pack_path=home_user_path+pack_path
packager_path=a1=pack_path+"/<myprog>"

# if the packager folder does not exist, create it
if not os.path.isdir(string.replace(packager_path,'<myprog>','')):
    try: os.mkdir(string.replace(packager_path,'<myprog>','')) #create the path
    except:
        print "impossible to create",packager_path
        exit()
    else:
        print packager_path,"has been created"
       
if __name__ == '__main__': main()

exit(0)

#------------------- End !---------------------


### HISTORY:
#
# Beginning of this project: April 27 2008
# Ver 0.10 - May 1st 2008
# This version seem running almost fine.
# Ver 0.11 Completed choice in categories (combo box)
# This is the first version released on my blog
# just for evaluation!

### INFO ABOUT  DATA
#


### INFO ABOUT FILES
#
# folder created: packageur in home/user directory
# 
